/* Generated by powerful Codeforces Tool
 * Author: $%U%$
 * Time: $%Y%$-$%M%$-$%D%$ $%h%$:$%m%$
 **/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b){ return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b){ return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MOD = 998'244'353;

const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

ll N, M, K;

void solve(){
    // Code goes here ...
    cin >> N >> M >> K;
    vector<ll> a(N);
    R(i, N) cin >> a[i];
    vector<ll> b(M), rb(M);
    R(i, M) cin >> b[i];

    // prep magic
    ll inverter = (1ll << 60) - 1;
    R(i, M) rb[i] = inverter ^ b[i];

    vector<set<ll>> magic(M);

    for(auto m : rb){

        F(i, 1, M){
            for(auto e : magic[i-1]){
                magic[i].insert(e | m);
            }
        }
        magic[0].insert(m);
   
    // F(i, 1, M){
    //     for(auto e: magic[i - 1]){
    //         for(auto m : magic[0]){
    //             // cerr << e << " " << m << " " << (e | m) << endl;
    //             if(e != m)
    //                 magic[i].insert(e | m);
    //         }
    //     }
    // }

    // for(auto s : magic){
    //     cerr << "size " << s.size() << endl;
    //     for(auto e : s){
    //         cerr << (inverter ^ e) << " ";
    //         // cerr << (e) << " ";
    //     }
    //     cerr << endl;
    // }


    vector<ll> values;

    for(ll x : a){
        ll prevgain = 0;
        for(auto s : magic){
            ll maxgain = 0;
            for(ll m : s)
                ckmax(maxgain, m & x);
            // cerr << x << " can gain " << maxgain << endl;
            if(maxgain - prevgain > 0)
                values.push_back(maxgain - prevgain);

            prevgain = maxgain;
        }
    }

    // for(auto v: values)
    //     cerr << v << " ";
    // cerr << endl;

    R::sort(values);
    R::reverse(values);
    

    ll res = 0;
    ll vs = values.size();
    R(i, min(K, vs)) res += values[i];
    ll s = reduce(a.begin(), a.end());
    // cerr << s << " " << res << endl;
    cout << (s - res) << endl;
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
